	
	-----------------------------------------
	-- FAIL - Lib 1.11 by Fail US-Ragnaros --
	-----------------------------------------

local _,FAIL_Lib = ...

local CreateFrame = CreateFrame

local upper,type,unpack = string.upper,type,unpack

function FAIL_Lib:FrameTemplate(data)
	data.type = data.type and upper(data.type)
	local frame = CreateFrame((data.type and (data.type == "STATUSBAR" and "FRAME") or data.type) or "FRAME",data.name,data.parent or UIParent,data.inherited,data.id)
	if data.allpoints then
		frame:SetAllPoints((type(data.allpoints) == "boolean" and (data.parent or UIParent)) or data.allpoints)
	else
		if type(data.point) == "table" then
			for i=1,#data.point do
				frame:SetPoint(data.point[i] or "CENTER",(type(data.relative) == "table" and data.relative[i]) or data.relative or data.parent or UIParent,(type(data.relativePoint) == "table" and data.relativePoint[i] ~= nil and data.relativePoint[i]) or data.point[i] or "CENTER",(type(data.xOff) == "table" and data.xOff[i] ~= nil and data.xOff[i]) or 0,(type(data.yOff) == "table" and data.yOff[i] ~= nil and data.yOff[i]) or 0)
			end
		else
			frame:SetPoint(data.point or "CENTER",data.relative or data.parent or UIParent,data.relativePoint or data.point or "CENTER",data.xOff or 0,data.yOff or 0)
		end
	end
	if data.width then frame:SetWidth(data.width) end
	if data.height then frame:SetHeight(data.height) end
	if data.backdrop then
		Mixin(frame,BackdropTemplateMixin)
		frame:SetBackdrop({
			bgFile = data.backdrop.bgFile or "Interface\\ChatFrame\\ChatFrameBackground",
			edgeFile = data.backdrop.edgeFile or "Interface\\ChatFrame\\ChatFrameBackground",
			tile = data.backdrop.tile,
			tileSize = data.backdrop.tileSize or 32,
			tileEdge = data.backdrop.tileEdge,
			edgeSize = data.backdrop.edgeSize or 1,
			insets = data.backdrop.insets or {left=1,right=1,top=1,bottom=1},
		})
		frame:SetBackdropColor(unpack(data.backdrop.color or {0,0,0,.5}))
		frame:SetBackdropBorderColor(unpack(data.backdrop.border or {0,0,0,1}))
	end
	if data.strata then frame:SetFrameStrata(data.strata) end
	if data.level then frame:SetFrameLevel(data.level) end
	if data.texture then
		for i=1,#data.texture do
			local texture = frame:CreateTexture(nil,data.texture[i].layer or "ARTWORK",data.texture[i].inherited,data.texture[i].sublayer)
			if data.texture[i].allpoints then
				texture:SetAllPoints((type(data.texture[i].allpoints) == "boolean" and frame) or data.texture[i].allpoints)
			else
				if type(data.texture[i].point) == "table" then
					for n=1,#data.texture[i].point do
						texture:SetPoint(data.texture[i].point[n] or "CENTER",(type(data.texture[i].relative) == "table" and data.texture[i].relative[n]) or data.texture[i].relative or frame,(type(data.texture[i].relativePoint) == "table" and data.texture[i].relativePoint[n] ~= nil and data.texture[i].relativePoint[n]) or data.texture[i].point[n] or "CENTER",(type(data.texture[i].xOff) == "table" and data.texture[i].xOff[n] ~= nil and data.texture[i].xOff[n]) or 0,(type(data.texture[i].yOff) == "table" and data.texture[i].yOff[n] ~= nil and data.texture[i].yOff[n]) or 0)
					end
				else
					texture:SetPoint(data.texture[i].point or "CENTER",data.texture[i].relative or frame,data.texture[i].relativePoint or data.texture[i].point or "CENTER",data.texture[i].xOff or 0,data.texture[i].yOff or 0)
				end
			end
			if data.texture[i].width then texture:SetWidth(data.texture[i].width) end
			if data.texture[i].height then texture:SetHeight(data.texture[i].height) end
			if data.texture[i].texture then texture:SetTexture(data.texture[i].texture) end
			if data.texture[i].atlas then texture:SetAtlas(data.texture[i].atlas) end
			if data.texture[i].coord then texture:SetTexCoord(unpack(data.texture[i].coord)) end
			if data.texture[i].color then texture:SetColorTexture(unpack(data.texture[i].color)) end
			if data.texture[i].vertex then texture:SetVertexColor(unpack(data.texture[i].vertex)) end
			if data.texture[i].hide then texture:Hide() end
			if data.texture[i].name then
				frame[data.texture[i].name] = texture
			else
				if #data.texture == 1 then
					frame.Texture = texture
				else
					frame["Texture"..i] = texture
				end
			end
		end
	end
	if data.text then
		for i=1,#data.text do
			local text = frame:CreateFontString(nil,data.text[i].layer or "ARTWORK",data.text[i].inherited or "GameFontNormal",data.text[i].sublayer)
			if data.text[i].allpoints then
				text:SetAllPoints((type(data.text[i].allpoints) == "boolean" and frame) or data.text[i].allpoints)
			else
				if type(data.text[i].point) == "table" then
					for n=1,#data.text[i].point do
						text:SetPoint(data.text[i].point[n] or "CENTER",(type(data.text[i].relative) == "table" and data.text[i].relative[n]) or data.text[i].relative or frame,(type(data.text[i].relativePoint) == "table" and data.text[i].relativePoint[n] ~= nil and data.text[i].relativePoint[n]) or data.text[i].point[n] or "CENTER",(type(data.text[i].xOff) == "table" and data.text[i].xOff[n] ~= nil and data.text[i].xOff[n]) or 0,(type(data.text[i].yOff) == "table" and data.text[i].yOff[n] ~= nil and data.text[i].yOff[n]) or 0)
					end
				else
					text:SetPoint(data.text[i].point or "CENTER",data.text[i].relative or frame,data.text[i].relativePoint or data.text[i].point or "CENTER",data.text[i].xOff or 0,data.text[i].yOff or 0)
				end
			end
			local font,size,flag = text:GetFont()
			text:SetFont(data.text[i].font or font,data.text[i].size or size,data.text[i].flag or flag)
			text:SetText(data.text[i].text or "")
			text:SetTextColor(unpack(data.text[i].color or {1,1,1,1}))
			text:SetJustifyH(data.text[i].horizontal or "CENTER")
			text:SetJustifyV(data.text[i].vertical or "CENTER")
			text:SetNonSpaceWrap(data.wrap)
			text:SetShadowOffset(unpack(data.text[i].shadow or {0,0}))
			if data.text[i].width then text:SetWidth(data.text[i].width) end
			if data.text[i].height then text:SetHeight(data.text[i].height) end
			if data.text[i].hide then text:Hide() end
			if data.text[i].name then
				frame[data.text[i].name] = text
			else
				if #data.text == 1 then
					frame.Text = text
				else
					frame["Text"..i] = text
				end
			end
		end
	end
	if data.type == "STATUSBAR" then
		frame.StatusBar = CreateFrame("STATUSBAR",nil,frame)
		if data.backdrop then
			frame.StatusBar:SetPoint("TOPRIGHT",frame,-1*((data.backdrop.insets and data.backdrop.insets.right and data.backdrop.insets.right) or 1),-1*((data.backdrop.insets and data.backdrop.insets.top and data.backdrop.insets.top) or 1))
			frame.StatusBar:SetPoint("BOTTOMLEFT",frame,((data.backdrop.insets and data.backdrop.insets.left and data.backdrop.insets.left) or 1),((data.backdrop.insets and data.backdrop.insets.bottom and data.backdrop.insets.bottom) or 1))
		else
			frame.StatusBar:SetAllPoints(frame)
		end
		frame.StatusBar:SetFrameLevel(frame:GetFrameLevel())
		frame.StatusBar:SetStatusBarTexture(data.statusbar or "Interface\\TARGETINGFRAME\\UI-StatusBar")
		frame.StatusBar:SetStatusBarColor(unpack(data.color or {1,1,1,1}))
		frame.StatusBar:SetMinMaxValues(data.min or 0,data.max or 0)
		frame.StatusBar:SetValue(data.value or data.min or 0)
		frame.StatusBar:SetFillStyle(data.style or "STANDARD")
		frame.StatusBar:SetReverseFill(data.reverse)
	elseif data.type == "SCROLLFRAME" and data.name and data.func then
		frame.ScrollBar = CreateFrame("SLIDER",data.name.."ScrollBar",frame,"MinimalScrollBarTemplate")
		frame.ScrollBar:SetPoint("TOPRIGHT",frame,"TOPRIGHT",-1,-17)
		frame.ScrollBar:SetPoint("BOTTOMLEFT",frame,"BOTTOMRIGHT",-19,16)
		frame.ScrollBar:SetMinMaxValues(data.min or 0,data.max or 0)
		frame.ScrollBar:SetValueStep(data.step or 1)
		frame.ScrollBar:SetValue(data.value or data.min or 0)
		frame.ScrollBar:SetObeyStepOnDrag(not data.drag)
		frame.ScrollBar.Track = _G[data.name.."ScrollBarTrack"]
		if not data.track then frame.ScrollBar.Track:Hide() end
		frame.ScrollBar.UpButton = _G[data.name.."ScrollBarScrollUpButton"]
		if data.disable or (data.value or data.min or 0) == (data.min or 0) then frame.ScrollBar.UpButton:Disable() end
		frame.ScrollBar.DownButton = _G[data.name.."ScrollBarScrollDownButton"]
		if data.disable or (data.value or data.min or 0) == (data.max or 0) then frame.ScrollBar.DownButton:Disable() end
		if data.disable or ((data.value or data.min or 0) == (data.min or 0) and (data.value or data.min or 0) == (data.max or 0)) then frame.ScrollBar:Disable() end
		frame:SetScript("OnMouseWheel",function(self,delta)
			if self.ScrollBar:IsEnabled() then self.ScrollBar:SetValue(self.ScrollBar:GetValue()-delta) end
		end)
		frame.ScrollBar.lastValue = (data.value or data.min or 0)-1
		frame.ScrollBar:SetScript("OnValueChanged",function(self,value)
			if self.lastValue == value then return end
			self.lastValue = value
			local min,max = self:GetMinMaxValues()
			if value == min then
				self.UpButton:Disable()
			else
				self.UpButton:Enable()
			end
			if value == max then
				self.DownButton:Disable()
			else
				self.DownButton:Enable()
			end
			if value == min and value == max then
				self:Disable()
			else
				self:Enable()
			end
			data.func(self,value)
		end)
	elseif data.type == "EDITBOX" then
		frame:SetMovable(false)
		frame:EnableMouse(true)
		frame:SetAutoFocus(data.autofocus or false)
		frame:SetNumeric(data.numeric or false)
		frame:SetMultiLine(data.multiline or false)
		frame:SetText(data.text or "")
		frame:SetFont(data.font or "Fonts\\FRIZQT__.TTF",data.size or 14,data.flag)
		if data.letters then frame:SetMaxLetters(data.letters) end
		if data.insets then frame:SetTextInsets(unpack(data.insets)) end
		if data.horizontal then frame:SetJustifyH(data.horizontal) end
		if data.vertical then frame:SetJustifyV(data.vertical) end
		if data.disable then frame:Disable() end
	end
	if data.movable then
		frame:EnableMouse(true)
		frame:SetMovable(true)
		frame:SetScript("OnMouseDown",function(self,button)
			if button ~= "LeftButton" then return end
			self:StartMoving()
		end)
		frame:SetScript("OnMouseUp",function(self,button)
			if button ~= "LeftButton" then return end
			self:StopMovingOrSizing()
		end)
	end
	if data.resizable then
		frame:EnableMouse(true)
		frame:SetResizable(true)
		if data.resizable.minimum then frame:SetMinResize(data.resizable.minimum[1],data.resizable.minimum[2]) end
		if data.resizable.maximum then frame:SetMaxResize(data.resizable.maximum[1],data.resizable.maximum[2]) end
		frame.Resize = CreateFrame("BUTTON",nil,frame)
		if type(data.resizable) == "table" then
			frame.Resize:SetPoint(data.resizable.point or "BOTTOMRIGHT",data.resizable.relative or frame,data.resizable.relativePoint or data.resizable.point or "BOTTOMRIGHT",data.resizable.xOff or 0,data.resizable.yOff or 0)
		else
			frame.Resize:SetPoint("BOTTOMRIGHT")
		end
		frame.Resize:SetSize(16,16)
		frame.Resize:SetNormalTexture("Interface\\ChatFrame\\UI-ChatIM-SizeGrabber-Down")
		frame.Resize:SetHighlightTexture("Interface\\ChatFrame\\UI-ChatIM-SizeGrabber-Highlight")
		frame.Resize:SetPushedTexture("Interface\\ChatFrame\\UI-ChatIM-SizeGrabber-Up")
		frame.Resize:SetScript("OnMouseDown",function(self)
			frame:StartSizing("BOTTOMRIGHT") 
		end)
		frame.Resize:SetScript("OnMouseUp",function(self)
			frame:StopMovingOrSizing()
		end)
	end
	if data.screen then frame:SetClampedToScreen(data.screen) end
	if data.attribute then
		for i=1,#data.attribute do
			frame:SetAttribute(data.attribute[i].type,data.attribute[i].attribute)
		end
	end
	if data.script then
		frame:EnableMouse(true)
		for i=1,#data.script do
			if frame:GetScript(data.script[i].type) then
				frame:HookScript(data.script[i].type,data.script[i].func)
			else
				frame:SetScript(data.script[i].type,data.script[i].func)
			end
		end
	end
	if data.event then
		for _,info in ipairs(data.event) do
			if type(info.event) == "table" then
				for _,event in ipairs(info.event) do
					frame[event] = info.func
					if info.unit then
						frame:RegisterUnitEvent(event,info.unit)
					elseif not info.unregister then
						frame:RegisterEvent(event)
					end
				end
			else
				frame[info.event] = info.func
				if info.unit then
					frame:RegisterUnitEvent(info.event,info.unit)
				elseif not info.unregister then
					frame:RegisterEvent(info.event)
				end
			end
		end
		frame:SetScript("OnEvent",function(self,event,...)
			self[event](data.event.self or self,event,...)
		end)
	end
	if data.hide then frame:Hide() end
	return frame
end